function pad(c) {
	var i = parseInt(c, 10);
	return (i < 10 ? '0' + i : c.toString());
}

var iSunriseSecondsSinceMidnight = 0;
var iSunsetSecondsSinceMidnight = 0;
var iDuskSecondsSinceMidnight = 0;
var iDawnSecondsSinceMidnight = 0;

function getAstroTimes() {
	if (iSunriseSecondsSinceMidnight != 0)
		return;
	var sunriseNode = Property.getNode('/config/geodata/sunrise');
	if (sunriseNode == null) {
		lWarn.logln('scheduleSunTimedEvents - no sunrise Infomation');
		return;
	}
	var sString = sunriseNode.getValue();
	var sArray = sString.split(':');
	if (sArray.length != 3) {
		lWarn.logln('scheduleSunTimedEvents - no sunrise Infomation');
		return;
	}
	iSunriseSecondsSinceMidnight = parseInt(sArray[2], 10);
	iSunriseSecondsSinceMidnight += parseInt(sArray[1], 10) * 60;
	iSunriseSecondsSinceMidnight += parseInt(sArray[0], 10) * 60 * 60;
	lInfo.logln('scheduleSunTimedEvents - sunrise at ' + sString + '; seconds since Midnight ' + iSunriseSecondsSinceMidnight);

	var sunsetNode = Property.getNode('/config/geodata/sunset');
	if (sunsetNode == null) {
		lWarn.logln('scheduleSunTimedEvents - no sunset Infomation');
		return;
	}
	sString = sunsetNode.getValue();
	sArray = sString.split(':');
	if (sArray.length != 3) {
		lWarn.logln('scheduleSunTimedEvents - no sunset Infomation');
		return;
	}
	iSunsetSecondsSinceMidnight = parseInt(sArray[2], 10);
	iSunsetSecondsSinceMidnight += parseInt(sArray[1], 10) * 60;
	iSunsetSecondsSinceMidnight += parseInt(sArray[0], 10) * 60 * 60;
	lInfo.logln('scheduleSunTimedEvents - sunset at ' + sString + '; seconds since Midnight ' + iSunsetSecondsSinceMidnight);

	var duskNode = Property.getNode('/config/geodata/civil_dusk');
	if (duskNode == null) {
		lWarn.logln('scheduleSunTimedEvents - no dusk Infomation');
		return;
	}
	sString = duskNode.getValue();
	sArray = sString.split(':');
	if (sArray.length != 3) {
		lWarn.logln('scheduleSunTimedEvents - no dusk Infomation');
		return;
	}
	iDuskSecondsSinceMidnight = parseInt(sArray[2], 10);
	iDuskSecondsSinceMidnight += parseInt(sArray[1], 10) * 60;
	iDuskSecondsSinceMidnight += parseInt(sArray[0], 10) * 60 * 60;
	lInfo.logln('scheduleSunTimedEvents - Dusk at ' + sString + '; seconds since Midnight ' + iDuskSecondsSinceMidnight);

	var dawnNode = Property.getNode('/config/geodata/civil_dawn');
	if (dawnNode == null) {
		lWarn.logln('scheduleSunTimedEvents - no dawn Infomation');
		return;
	}
	sString = dawnNode.getValue();
	sArray = sString.split(':');
	if (sArray.length != 3) {
		lWarn.logln('scheduleSunTimedEvents - no dawn Infomation');
		return;
	}
	iDawnSecondsSinceMidnight = parseInt(sArray[2], 10);
	iDawnSecondsSinceMidnight += parseInt(sArray[1], 10) * 60;
	iDawnSecondsSinceMidnight += parseInt(sArray[0], 10) * 60 * 60;
	lInfo.logln('scheduleSunTimedEvents - Dawn at ' + sString + '; seconds since Midnight ' + iDawnSecondsSinceMidnight);

}

function deleteSunriseEvents() {
	lInfo.logln('deleteSunriseEvents');
	var aOldNotes = Property.getNode('dynamic/scheduledDynamicEvents');
	if (aOldNotes != null) {
		lInfo.logln('deleteTimedEvents - remove old');
		var queue = aOldNotes.getChildren();

		for ( var i = 0; i < queue.length; ++i) {
			var propNode = Property.getNode('/system/EventInterpreter/ScheduledEvents/' + queue[i].getValue());
			if (propNode) {
				propNode.getParent().removeChild(propNode);
			}
			lInfo.logln('deleteTimedEvents - remove old #' + i);
		}
	}
	var aOldNotes = Property.getNode('dynamic');
	if (aOldNotes != null)
		aOldNotes.removeChild('timedEvents_suntime');
}

function deleteTimedEvents() {
	lInfo.logln('deleteTimedEvents');
	var aOldNotes = Property.getNode('dynamic/scheduledFixedEvents');
	if (aOldNotes != null) {
		lInfo.logln('deleteTimedEvents - remove old');
		var queue = aOldNotes.getChildren();

		for ( var i = 0; i < queue.length; ++i) {
			var propNode = Property.getNode('/system/EventInterpreter/ScheduledEvents/' + queue[i].getValue());
			if (propNode) {
				propNode.getParent().removeChild(propNode);
			}
			lInfo.logln('deleteTimedEvents - remove old #' + i);
		}
	}
	var aOldNotes = Property.getNode('dynamic');
	if (aOldNotes != null)
		aOldNotes.removeChild('timedEvents');
}

function resetOneEvent(path) {
	if (Property.getNode(path) == null)
		return;
	var queueID = Property.getNode(path).getValue();
	var propNode = Property.getNode('/system/EventInterpreter/ScheduledEvents/' + queueID);
	if (propNode) {
		propNode.getParent().removeChild(propNode);
	}
	Property.getNode(path).getParent().removeChild(Property.getNode(path));
}

function setOneEvent(oEvent) {
	try {
		getAstroTimes();
		lInfo.logln('setOneEvent - make: ' + oEvent.getPath());

		var dold = new Date();
		dold.setTime(dold.getTime() - (1000 * 60 * 60 * 24 * 7));
		var fMultiple = false;
		var doldArray = [];
		var lastDateOnAbsolute;

		var sRRule = "FREQ=WEEKLY;BYDAY=" + oEvent.getChild('recurrence/recurrenceOffset').getValue();

		lInfo.logln('setOneEvent - recurrence rule is ' + sRRule);

		if (oEvent.getChild('time/timeBase').getValue() == 'daily') // nur
																	// statische
																	// Events
																	// hier
		{
			resetOneEvent('dynamic/scheduledFixedEvents/' + oEvent.getChild('id').getValue());
			lInfo.logln('setOneEvent - it has a fixed time');

			var timeValue = Math.abs(oEvent.getChild('time/offset').getValue());
			var iTempStartTime;

			iTempStartTime = new Date();
			iTempStartTime.setFullYear(dold.getFullYear());
			iTempStartTime.setMonth(dold.getMonth());
			iTempStartTime.setDate(dold.getDate());
			iTempStartTime.setHours(Math.floor(timeValue / 3600));
			iTempStartTime.setMinutes(Math.floor(timeValue / 60) % 60);
			iTempStartTime.setSeconds(timeValue % 60);
			iTempStartTime = iTempStartTime.getTime();

			var iCalStartTime = dold.getFullYear() + pad(dold.getMonth() + 1) + pad(dold.getDate()) + 'T' + pad(Math.floor(timeValue / 3600)) + pad(Math.floor(timeValue / 60) % 60)
					+ pad(timeValue % 60);

			var timerEvent;

			lInfo.logln('setOneEvent - insert start : ' + iCalStartTime + ' rrule: ' + sRRule);

			var actionParameter = {
				'zoneID' : oEvent.getChild('target').getValue(),
			}
			if (oEvent.getChild('desiredMode') != null) {
				actionParameter.actions = 'setOperationMode';
				actionParameter.operationMode = oEvent.getChild('desiredMode').getValue();
			} else {
				actionParameter.actions = 'resetOperationMode';
				actionParameter.operationMode = oEvent.getChild('resetingMode').getValue();
			}
			timerEvent = new TimedICalEvent('heating-controller.operation-mode', iCalStartTime, sRRule, actionParameter);
			Property.setProperty('dynamic/scheduledFixedEvents/' + oEvent.getChild('id').getValue(), timerEvent.raise());

		} else {

			resetOneEvent('dynamic/scheduledDynamicEvents/' + oEvent.getChild('id').getValue());
			lInfo.logln('setOneEvent - it has a ' + oEvent.getChild('time/timeBase').getValue() + ' time');

			var timeValue = oEvent.getChild('time/offset').getValue();

			switch (oEvent.getChild('time/timeBase').getValue()) {
			case 'sunrise':
				timeValue += iSunriseSecondsSinceMidnight;
				break;
			case 'sunset':
				timeValue += iSunsetSecondsSinceMidnight;
				break;
			case 'dusk':
				timeValue += iDuskSecondsSinceMidnight;
				break;
			case 'dawn':
				timeValue += iDawnSecondsSinceMidnight;
				break;
			}

			if (oEvent.getChild('time/limitBefore') != null) {
				if (timeValue > oEvent.getChild('time/limitBefore').getValue())
					timeValue = oEvent.getChild('time/limitBefore').getValue();
			}
			if (oEvent.getChild('time/limitAfter') != null) {
				if (timeValue < oEvent.getChild('time/limitAfter').getValue())
					timeValue = oEvent.getChild('time/limitAfter').getValue();
			}

			var iCalStartTime;
			var iTempStartTime;

			iCalStartTime = dold.getFullYear() + pad(dold.getMonth() + 1) + pad(dold.getDate()) + 'T' + pad(Math.floor(timeValue / 3600)) + pad(Math.floor(timeValue / 60) % 60) + pad(timeValue % 60);

			iTempStartTime = new Date();
			iTempStartTime.setFullYear(dold.getFullYear());
			iTempStartTime.setMonth(dold.getMonth());
			iTempStartTime.setDate(dold.getDate());
			iTempStartTime.setHours(Math.floor(timeValue / 3600));
			iTempStartTime.setMinutes(Math.floor(timeValue / 60) % 60);
			iTempStartTime.setSeconds(timeValue % 60);
			iTempStartTime = iTempStartTime.getTime();
			var timerEvent;

			var actionParameter = {
				'zoneID' : oEvent.getChild('target').getValue(),
			}
			if (oEvent.getChild('desiredMode') != null) {
				actionParameter.actions = 'setOperationMode';
				actionParameter.desiredOperationMode = oEvent.getChild('desiredMode').getValue();
			} else {
				actionParameter.actions = 'resetOperationMode';
				actionParameter.desiredOperationMode = oEvent.getChild('resetingMode').getValue();
			}

			lInfo.logln('setOneEvent - insert start : ' + iCalStartTime + ' rrule: ' + sRRule);
			timerEvent = new TimedICalEvent('heating-controller.operation-mode', iCalStartTime, sRRule, actionParameter);

			Property.setProperty('dynamic/scheduledDynamicEvents/' + oEvent.getChild('id').getValue(), timerEvent.raise());
		}
	} catch (e) {
		lWarn.logln("FEHLER beim setzen des Timers fr " + oEvent.name + " : " + e);
	}
}

function queueAllTimedProfiles() {
	Property.load();
	lInfo.logln('queueTimedProfiles');
	var parentEvents = Property.getNode('time-profile');
	if (parentEvents != null) {
		var aEvents = parentEvents.getChildren();
		for ( var iIndex = 0; iIndex < aEvents.length; iIndex++) {
			try {
				var oEvent = aEvents[iIndex];
				lInfo.logln('queueTimedProfiles - adding #' + oEvent.getChild('id').getValue());
				setOneEvent(oEvent);
			} catch (e) {
				lWarn.logln("FEHLER beim setzen des Timers fr " + oEvent.iIndex + " : " + e);
			}
		}
	}
}

function checkIfSmartPhoneNode (oNode) {
	try {
		var sString=oNode.getChild('metaData').getValue();	
		var oMetaObject=JSON.parse(sString);
		if (oMetaObject.origin!=null) {
			if (oMetaObject.origin=='smartphone.climatecontrol')
				return true;
		}
	} catch (e) {
		return false;
	}	
	return false;
}

function ensureSingularity(priority) {
	// wenn metadata ein {'origin':'smartphone.climatecontrol'} enthlt, dann doppelte lschen. Im Zweifelsfalle nach Priority entscheiden oder komplett lschen
	
	lInfo.logln('ensureSingularity : start');
	var Nodes=Property.getNode('time-profile').getChildren();
	var TE={};
	for (var iIndex=0;iIndex<Nodes.length;iIndex++) {
		if (checkIfSmartPhoneNode(Nodes[iIndex])) {
			var target=Nodes[iIndex].getChild('target').getValue();
			if (TE[target]==null)
				TE[target]={};
			var weekday=Nodes[iIndex].getChild('recurrence/recurrenceOffset').getValue();
			if (TE[target][weekday]==null)
				TE[target][weekday]={};
			
			if (Nodes[iIndex].getChild('resetingMode')!=null) {
				var mode=Nodes[iIndex].getChild('resetingMode').getValue();
				if (TE[target][weekday][mode]==null) {
					TE[target][weekday][mode]={
							reset:[],
							set:[]
					};
				}
				TE[target][weekday][mode].reset.push(Nodes[iIndex]);
			}
			if (Nodes[iIndex].getChild('desiredMode')!=null) {
				var mode=Nodes[iIndex].getChild('desiredMode').getValue();
				if (TE[target][weekday][mode]==null) {
					TE[target][weekday][mode]={
							reset:[],
							set:[] };
				}
				TE[target][weekday][mode].set.push(Nodes[iIndex]);
			}
		}
	}	
	var aArrayForRemove=[];
	for (var sTarget in TE)
		for (var sWeekday in TE[sTarget])
		for (var sMode in TE[sTarget][sWeekday]) {
			lInfo.logln('ensureSingularity : check double entry set for target ' + sTarget + ' in mode ' + sMode + ' on day ' + sWeekday);
			if (TE[sTarget][sWeekday][sMode].set.length>1) {
				lInfo.logln('ensureSingularity : found a double entry set for target ' + sTarget + ' in mode ' + sMode + ' on day ' + sWeekday);
				for (var iIndex=0;iIndex<TE[sTarget][sWeekday][sMode].set.length;iIndex++) {
					var fFound=false;
					var nodeID=TE[sTarget][sWeekday][sMode].set[iIndex].getChild('id').getValue();
					for (var jIndex=0;jIndex<priority.length;jIndex++) {
						if (priority[jIndex]==nodeID) {
							fFound=true;
							lInfo.logln('node should survive: ' + nodeID);
						}
					}
					if (!fFound) {
						lInfo.logln('should remove node ' + nodeID)
						aArrayForRemove.push(nodeID);
					}
				}
 			}
			if (TE[sTarget][sWeekday][sMode].reset.length>1) {
				lInfo.logln('ensureSingularity : found a double entry reset for target ' + sTarget + ' in mode ' + sMode + ' on day ' + sWeekday);
				for (var iIndex=0;iIndex<TE[sTarget][sWeekday][sMode].reset.length;iIndex++) {
					var fFound=false;
					var nodeID=TE[sTarget][sWeekday][sMode].reset[iIndex].getChild('id').getValue();
					for (var jIndex=0;jIndex<priority.length;jIndex++) {
						if (priority[jIndex]==nodeID) {
							fFound=true;
							lInfo.logln('node should survive: ' + nodeID);
						}
					}
					if (!fFound) {
						lInfo.logln('should remove node ' + nodeID)
						aArrayForRemove.push(nodeID);
					}
				}
			}
		}
	
	for ( var iIndex=0;iIndex<aArrayForRemove.length;iIndex++) {
		var sKey=aArrayForRemove[iIndex];
		lInfo.logln('ensureSingularity : remove NOW Smartphone entry ' + sKey);
		resetOneEvent('dynamic/scheduledFixedEvents/' + sKey);
		Property.getNode('time-profile').removeChild(sKey);
	}
	
}

function removeOldEntries(referenceValue) {
	lInfo.logln('removeOldEntries referenceValue ' + JSON.stringify(referenceValue));
	//return;
	var arrayToRemove=[];
	var fNight=false;
	if (referenceValue.desiredMode!=null) {
		if (referenceValue.desiredMode==4) {
			fNight=true;
        }
    }
	if (referenceValue.resetingMode!=null) {
		if (referenceValue.resetingMode==4) {
			fNight=true;
        }
    }
	var referenceRecurrence=referenceValue.recurrence.recurrenceOffset;
	
	lInfo.logln('original id ' + referenceValue.id + ' zone ' + referenceValue.target + ' reccur ' +referenceRecurrence + ' offset '+referenceValue.time.offset);
	 
    if (fNight) {
        if (referenceValue.time.offset<12*60*60) {
            switch (referenceRecurrence) {
                case 'MO':
                    referenceRecurrence='SO';
                break;
                case 'TU':
                    referenceRecurrence='MO';
                break;
                case 'WE':
                    referenceRecurrence='TU';
                break;
                case 'TH':
                    referenceRecurrence='WE';
                break;
                case 'FR':
                    referenceRecurrence='TH';
                break;
                case 'SA':
                    referenceRecurrence='FR';
                break;
                case 'SU':
                    referenceRecurrence='SA';
                break;
            }
        }
    }	
	
	lInfo.logln('original id ' + referenceValue.id + ' zone ' + referenceValue.target + ' reccur ' +referenceRecurrence);

	var oArray=Property.getNode('time-profile').getChildren(); 
	for (var iIndex=0;iIndex<oArray.length;iIndex++){
		var oNode=oArray[iIndex];
		
		var targetZone=null;
		if (oNode.getChild('target')!=null)
			targetZone=oNode.getChild('target').getValue();
		
		var targetRecurrence=null;
		if (oNode.getChild('recurrence/recurrenceOffset')!=null)
			targetRecurrence=oNode.getChild('recurrence/recurrenceOffset').getValue();
		
		var targetOffset=null;
		if (oNode.getChild('time/offset')!=null)
			targetOffset=oNode.getChild('time/offset').getValue();
		
		var targetId=null;
		if (oNode.getChild('id')!=null)
			targetId=oNode.getChild('id').getValue();

		
		if (fNight) {
			
			if (targetOffset<12*60*60) {
				switch (targetRecurrence) {
					case 'MO':
						targetRecurrence='SO';
					break;
					case 'TU':
						targetRecurrence='MO';
					break;
					case 'WE':
						targetRecurrence='TU';
					break;
					case 'TH':
						targetRecurrence='WE';
					break;
					case 'FR':
						targetRecurrence='TH';
					break;
					case 'SA':
						targetRecurrence='FR';
					break;
					case 'SU':
						targetRecurrence='SA';
					break;
				}
			}
		}
		
	
		if (targetZone!=null)
			if (targetRecurrence!=null)
				if (targetId!=null)
					if (targetId!=referenceValue.id)
						if (targetZone==referenceValue.target) {
							lInfo.logln('reference id ' + targetId + ' zone ' + targetZone + ' reccur ' +targetRecurrence);						
							if (targetRecurrence==referenceRecurrence) {
								//right time, right zone, not actual id
								if (referenceValue.desiredMode!=null) {
									if (oNode.getChild('desiredMode')!=null)
										if (referenceValue.desiredMode==oNode.getChild('desiredMode').getValue()) {
                                            //if ((targetOffset === 43200) || (referenceValue.time.offset !== targetOffset)) {
                                                lInfo.logln('remove it');
                                                arrayToRemove.push(oNode);
                                            //}
										}
											
								}
								if (referenceValue.resetingMode!=null) {
									if (oNode.getChild('resetingMode')!=null)
										if (referenceValue.resetingMode==oNode.getChild('resetingMode').getValue()) {
                                            //if ((targetOffset === 43140) || (referenceValue.time.offset !== targetOffset)) {
                                                lInfo.logln('remove it');
                                                arrayToRemove.push(oNode);
                                            //}
										}
																				
								}
							}
						}
	}
	for (var iIndex=0;iIndex<arrayToRemove.length;iIndex++) {
		var oNode=arrayToRemove[iIndex];
		lInfo.logln('remove old entry ' + oNode.getChild('id').getValue());
		resetOneEvent('dynamic/scheduledFixedEvents/' + oNode.getChild('id').getValue());
		Property.getNode('time-profile').removeChild(oNode.getChild('id').getValue());
	}

}

function saveAction() {
	if (raisedEvent.parameter.value == null) {
		return -1;
	}
	try {
		var nowDate=Math.floor(new Date().getTime()/1000);
        //lInfo.logln('saveAction raisedEvent.parameter.value: ' + raisedEvent.parameter.value);
		var fFlexibleEntriesPossible=false;
		if (raisedEvent.parameter.flexible!=null)
			fFlexibleEntriesPossible=raisedEvent.parameter.flexible;
        var oArray;
		oArray = JSON.parse(unescape(raisedEvent.parameter.value));

        lInfo.logln('saveAction '+ JSON.stringify(oArray));
        
        if (!fFlexibleEntriesPossible) {
			
	        var removeItems=[];
	   		for ( var iIndex = 0; iIndex < oArray.length; iIndex++) {
				var oValue = oArray[iIndex];
	   			var targetZone=parseInt(''+oValue.target,10);
				var fFound=false;
				for (var jIndex=0;jIndex<removeItems.length;jIndex++)
					if (removeItems[jIndex]==targetZone)
						fFound=true;
	   			if (!fFound) {
	   				removeItems.push(targetZone);
	   			
	   			}
			}
			for (var jIndex=0;jIndex<removeItems.length;jIndex++) {
				var zoneID=removeItems[jIndex];
				lInfo.logln('Removing all items from zone ' + zoneID);
                if (Property.getNode('time-profile')) {
                    var oOldArray=Property.getNode('time-profile').getChildren(); 

                    for (var iIndex=0;iIndex<oOldArray.length;iIndex++){
                        var oNode=oOldArray[iIndex];
                        if (oNode.getChild('target')!=null) {
                            var targetZone=oNode.getChild('target').getValue();
                            if (targetZone==zoneID) {
                                resetOneEvent('dynamic/scheduledFixedEvents/' + oNode.getChild('id').getValue());
                                Property.getNode('time-profile').removeChild(oNode.getChild('id').getValue());
                            }
                        } else {
                            if (oNode.getChild('id')!=null) {
                                lWarn.logln('heating-controller.time-profile this profile has no target, so kick it' + oNode.getChild('id').getValue());
                                resetOneEvent('dynamic/scheduledFixedEvents/' + oNode.getChild('id').getValue());
                                Property.getNode('time-profile').removeChild(oNode.getChild('id').getValue());
                            } else {
                                lWarn.logln('heating-controller.time-profile deleteTimeline: something is very very wrong with this node ' + oNode.getPath());
                            }
                        }
                    }	
                }
			}
        }
   		var newIDArray = [];
   		for ( var iIndex = 0; iIndex < oArray.length; iIndex++) {
			var oValue = oArray[iIndex];
			if (oValue.id == null) {
				oValue.id = generateID();
			}
			lInfo.logln('saveing ID ' + oValue.id + ' desiredMode ' + oValue.desiredMode + ' resetingMode ' + oValue.resetingMode + ' offset ' + oValue.time.offset +' recurrenceOffset '+oValue.recurrence.recurrenceOffset);
			if (Property.getNode('time-profile')){
                Property.getNode('time-profile').removeChild(oValue.id);
            }
			newIDArray.push(oValue.id);
			storeParameter("time-profile/" + oValue.id + "/id", oValue.id);
			if (oValue.desiredMode != null) {
				storeParameter("time-profile/" + oValue.id + "/desiredMode", oValue.desiredMode);
				Property.getNode("time-profile/" + oValue.id).removeChild('resetingMode');
			} else if (oValue.resetingMode != null) {
				storeParameter("time-profile/" + oValue.id + "/resetingMode", oValue.resetingMode);
				Property.getNode("time-profile/" + oValue.id).removeChild('desiredMode');
			}
			storeParameter("time-profile/" + oValue.id + "/target", parseInt(''+oValue.target,10));

			storeParameter("time-profile/" + oValue.id + "/time/offset", oValue.time.offset);
			storeParameter("time-profile/" + oValue.id + "/time/timeBase", oValue.time.timeBase);
			if (oValue.time.limitBefore != null)
				storeParameter("time-profile/" + oValue.id + "/time/limitBefore", oValue.time.limitBefore);
			if (oValue.time.limitAfter != null)
				storeParameter("time-profile/" + oValue.id + "/time/limitAfter", oValue.time.limitAfter);
			storeParameter("time-profile/" + oValue.id + "/recurrence/recurrenceBase", oValue.recurrence.recurrenceBase);
			storeParameter("time-profile/" + oValue.id + "/recurrence/recurrenceOffset", oValue.recurrence.recurrenceOffset);

			if (oValue.disabled != null)
				storeParameter("time-profile/" + oValue.id + "/disabled", oValue.disabled);
			else
				storeParameter("time-profile/" + oValue.id + "/disabled", false);

			if ((oValue.metaData != null) && (oValue.metaData != ""))
				storeParameter("time-profile/" + oValue.id + "/metaData", "" + JSON.stringify(oValue.metaData));
			else
				if (Property.getNode("time-profile/" + oValue.id + "/metaData")==null)
					storeParameter("time-profile/" + oValue.id + "/metaData", "");			
		}
		
		Property.store();
		for ( var iIndex = 0; iIndex < newIDArray.length; iIndex++) {
			lInfo.logln('saveAction calls setOneEvent with index ' + iIndex + ' and id ' + newIDArray[iIndex]);
			if (Property.getNode("time-profile/" + newIDArray[iIndex])!=null)
				setOneEvent(Property.getNode("time-profile/" + newIDArray[iIndex]));
			else
				lWarn.logln('node ' +newIDArray[iIndex] + 'is missing');
		}
	} catch (e) {
		lWarn.logln('heating-controller.time-profile saveAction:' + e);
	}
	return 0;
}

function deleteTimeline() {
	if (raisedEvent.parameter.zoneID == null) 
		return -1;	
	try {
		var zoneID=parseInt('' + raisedEvent.parameter.zoneID,10);
		
		var oArray=Property.getNode('time-profile').getChildren(); 
		
		for (var iIndex=0;iIndex<oArray.length;iIndex++){
			var oNode=oArray[iIndex];
			if (oNode.getChild('target')!=null) {
				var targetZone=oNode.getChild('target').getValue();
				if (targetZone==zoneID) {
					resetOneEvent('dynamic/scheduledFixedEvents/' + oNode.getChild('id').getValue());
					Property.getNode('time-profile').removeChild(oNode.getChild('id').getValue());
				}
			} else {
				if (oNode.getChild('id')!=null) {
					lWarn.logln('heating-controller.time-profile this profile has no target, so kick it' + oNode.getChild('id').getValue());
					resetOneEvent('dynamic/scheduledFixedEvents/' + oNode.getChild('id').getValue());
					Property.getNode('time-profile').removeChild(oNode.getChild('id').getValue());
				} else {
					lWarn.logln('heating-controller.time-profile deleteTimeline: something is very very wrong with this node ' + oNode.getPath());
				}
			}
		}
		
	} catch (e) {
		lWarn.logln('heating-controller.time-profile deleteTimeline:' + e);
	}
	return 0;
}

function optimizeTimeline() {
	lInfo.logln('start optimize');
	var Nodes=Property.getNode('time-profile').getChildren();
	var TE={};
	try {
	for (var iIndex=0;iIndex<Nodes.length;iIndex++) {
	//	lInfo.logln('fetching info for ' + Nodes[iIndex].getName());
		var target=Nodes[iIndex].getChild('target').getValue();
		if (TE[target]==null)
			TE[target]={};
		var mode=-1;
		if (Nodes[iIndex].getChild('desiredMode')!=null)
			mode=Nodes[iIndex].getChild('desiredMode').getValue();
		if (Nodes[iIndex].getChild('resetingMode')!=null)
			mode=Nodes[iIndex].getChild('resetingMode').getValue();
		if (TE[target][mode]==null)
			TE[target][mode]=[];
		TE[target][mode].push(Nodes[iIndex]);
	}
			
	var aArrayForRemove=[];
	for (var sTarget in TE) {
		//lInfo.logln('targetZone ' + sTarget);
		for (var sMode in TE[sTarget]) {
			//lInfo.logln('targetMode ' + sMode);
			var oArray=TE[sTarget][sMode];
			//lInfo.logln('start sort');
			var oNewArray=oArray.sort(function (a,b) {
				
				var aDay=a.getChild('recurrence/recurrenceOffset').getValue();
				var bDay=b.getChild('recurrence/recurrenceOffset').getValue();
				if (aDay==bDay) {
					return a.getChild('time/offset').getValue()-b.getChild('time/offset').getValue();
				} else {
					var aDayValue=0;
					switch (aDay) {
						case 'MO':
							aDayValue=0;
						break;
						case 'TU':
							aDayValue=1;
						break;
						case 'WE':
							aDayValue=2;
						break;
						case 'TH':
							aDayValue=3;
						break;
						case 'FR':
							aDayValue=4;
						break;
						case 'SA':
							aDayValue=5;
						break;
						case 'SU':
							aDayValue=6;
						break;
					}
					var bDayValue=0;
					switch (bDay) {
						case 'MO':
							bDayValue=0;
						break;
						case 'TU':
							bDayValue=1;
						break;
						case 'WE':
							bDayValue=2;
						break;
						case 'TH':
							bDayValue=3;
						break;
						case 'FR':
							bDayValue=4;
						break;
						case 'SA':
							bDayValue=5;
						break;
						case 'SU':
							bDayValue=6;
						break;
					}
					return (aDayValue-bDayValue);
				}
			});
			//lInfo.logln('end sort ' + oNewArray.length);

			var evtStartIndex=-1;
			var startIndex=-1;
			// 1. set nach einem reset finden
			var fLast=false;
			for (var iIndex=0;(iIndex<oNewArray.length)&&(startIndex==-1);iIndex++) {
				if (oNewArray[iIndex].getChild('resetingMode')!=null) {
					fLast=true;
					lInfo.logln('found a reset for index ' + iIndex);
				}
					
				if (fLast) {
					if (oNewArray[iIndex].getChild('desiredMode')!=null) {
						startIndex=iIndex;
						lInfo.logln('found a set for index ' + iIndex);
					}
				} else {
					if (oNewArray[iIndex].getChild('desiredMode')!=null) {
						if (evtStartIndex==-1)
							evtStartIndex=iIndex;
					}
				}
					
			}
			if (startIndex==-1)
				startIndex=evtStartIndex;
//			lInfo.logln('StartIndex ' + startIndex);
			var setNode=null;
			var resetNode=null;
			if (startIndex>=0)
			for (var iIndex=0;iIndex<oNewArray.length;iIndex++) {
				var node=oNewArray[(iIndex+startIndex)%oNewArray.length];
//				lInfo.logln('Check id '+ node.getChild('id').getValue());
				if (setNode!=null) {
					if (node.getChild('desiredMode')!=null) {
						
						if (node.getChild('metaData')!=null)
							if (node.getChild('metaData').getValue()!="") {
								if ((setNode.getChild('metaData')==null) || (setNode.getChild('metaData').getValue()=="")) {
									storeProperty(setNode.getPath()+'/metaData',node.getChild('metaData').getValue());	
								}
							}
									
							
						aArrayForRemove.push(node.getChild('id').getValue());
		//				lInfo.logln('set : delete it '+ node.getChild('id').getValue());
					} else {
			//			lInfo.logln('Change to Reset');
						setNode=null;
						resetNode=node;
					}
				} else
				if (resetNode!=null) {
					if (node.getChild('resetingMode')!=null) {

						if (resetNode.getChild('metaData')!=null)
							if (resetNode.getChild('metaData').getValue()!="") {
								if ((node.getChild('metaData')==null) || (node.getChild('metaData').getValue()=="")) {
									storeProperty(node.getPath()+'/metaData',resetNode.getChild('metaData').getValue());	
								}
							}

						
						aArrayForRemove.push(resetNode.getChild('id').getValue());
				//		lInfo.logln('reset : delete it '+ resetNode.getChild('id').getValue());
						resetNode=node;
					} else {
					//	lInfo.logln('Change to Set');
						resetNode=null;
						setNode=node;
					}
				}
				if ((setNode==null)&&(resetNode==null)) {
					if (node.getChild('resetingMode')!=null) {
//						lInfo.logln('Startin Mode with Reset');
						resetNode=node;
					} else {
	//					lInfo.logln('Startin Mode with Set');
						setNode=node;
					}
				}
			}
		}
	}	
	for ( var iIndex=0;iIndex<aArrayForRemove.length;iIndex++) {
		var sKey=aArrayForRemove[iIndex];
		lInfo.logln('remove NOW ' + sKey);
		resetOneEvent('dynamic/scheduledFixedEvents/' + sKey);
		Property.getNode('time-profile').removeChild(sKey);
	}
	} catch (e) {
		lWarn.logln('Error on optimzie ' + e);
	}
}



if (raisedEvent.name == 'heating-controller.time-profile') {
	if (raisedEvent.parameter.actions != null) {
		if (raisedEvent.parameter.actions == "queueAllEvents") {
			queueAllTimedProfiles();
		};
		if (raisedEvent.parameter.actions == "optimizeTimeline") {
			optimizeTimeline();
			Property.store();
		}
		if (raisedEvent.parameter.actions == "optimizeTimelineDayBased") {
			optimizeTimelineDayBased();
			Property.store();
		}				
		if (raisedEvent.parameter.actions == 'save') {
			var resultValue = saveAction();
			new Event('heating-controller.answer', {
				'requestingEvent' : 'heating-controller.time-profile',
				'requestingAction' : 'save',
				'result' : resultValue
			}).raise();
		}
		if (raisedEvent.parameter.actions == 'delete') {
			if (raisedEvent.parameter.id != null) {
				var oIDObject = JSON.parse(unescape(raisedEvent.parameter.id));
				if (typeof (oIDObject) != 'object')
					oIDObject = [ oIDObject ];
				for ( var sKey in oIDObject) {
					if (Property.getNode('time-profile') != null) {
						resetOneEvent('dynamic/scheduledFixedEvents/' + oIDObject[sKey]);
						Property.getNode('time-profile').removeChild(oIDObject[sKey]);
					}
				}
				Property.store();
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.time-profile',
					'requestingAction' : 'delete',
					'result' : 0
				}).raise();
			}
		}
		if (raisedEvent.parameter.actions == 'deleteTimeline') {
			deleteTimeline();
			Property.store();
			if ((raisedEvent.parameter.noAnswer==null) || (raisedEvent.parameter.noAnswer==false))
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.time-profile',
					'requestingAction' : 'delete',
					'result' : 0
				}).raise();
		}
		if (raisedEvent.parameter.actions == 'enable') {
			if (raisedEvent.parameter.id != null) {
				if (Property.getNode('time-profile/' + raisedEvent.parameter.id) != null) {
					storeParameter('time-profile/' + raisedEvent.parameter.id + '/disabled', false);
					Property.store();
				}
			}
			new Event('heating-controller.answer', {
				'requestingEvent' : 'heating-controller.time-profile',
				'requestingAction' : 'enable',
				'result' : 0
			}).raise();
		}
		if (raisedEvent.parameter.actions == 'disable') {
			if (raisedEvent.parameter.id != null) {
				if (Property.getNode('time-profile/' + raisedEvent.parameter.id) != null) {
					storeParameter('time-profile/' + raisedEvent.parameter.id + '/disabled', true);
					Property.store();
				}
			}
			new Event('heating-controller.answer', {
				'requestingEvent' : 'heating-controller.time-profile',
				'requestingAction' : 'disable',
				'result' : 0
			}).raise();
		}
	}
}