Ext.define('DSS.addon.DeleteEditor', {
	extend : 'Ext.window.Window',
	cboBox:null,
	initial:null,
	buttonSave : null,
	buttonCancel : null,
	base:null,
	constructor : function(config) {
		var me = this;
		this.value = {};
		config.closeAction = 'hide';
		config.modal = true;
		config.height = 120;
		config.width = 350;
		config.layout = 'fit';
		config.appName = '';
		config.resizable = false;
		me.base=config.base;
		config.title = _('reset timeprofile for a zone');
		this.initial = Ext.create('Ext.panel.Panel', {
			html : '<span style="color:#005138;">' + _('select the zone which timeprofile should be resetted') + '</span>',
			width : 320,
			height : 25,
			border : false
		});
		

		this.cboBox=Ext.create('Ext.form.field.ComboBox', {
			editable:false,
	        store: Ext.data.StoreManager.lookup('usableZones'),
	        queryMode: 'local',
	        displayField: 'name',
	        valueField: 'id',                               
	        fieldLabel : _('zone'),
	        labelWidth:50,
	        width : 300,
	        padding: "0 5 0 0"
	    });
		
		me.buttonSave = Ext.create('Ext.Button', {
			text : _('remove'),
			handler : function() {
				me.base.removeTimeline(me.cboBox.getValue());
				me.hide();
			}
		});
		me.buttonCancel = Ext.create('Ext.Button', {
			text : _('cancel'),
			handler : function() {
				me.hide();
			}
		});
		this.displayBottomText = Ext.create('Ext.form.field.Display', {
			border : 0,
			value : '',
			style : {
				fontSize : '11px'
			},
			padding : '0 0 2 5',
			flex : 1
		});
		
		Ext.apply(me, {
			items : [ {
				xtype : 'panel',
				items : [this.initial,this.cboBox],
				bodyPadding : 5,
				border : 0,
				dockedItems : [ {
					xtype : 'toolbar',
					dock : 'bottom',
					ui : 'footer',
					defaults : {
						minWidth : 75
					},
					items : ['->',me.buttonSave,me.buttonCancel]
				} ]
			} ]
		}); // Ext.apply
		this.callParent(arguments);
	}
});
